(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13047,        429]
NotebookOptionsPosition[     11423,        372]
NotebookOutlinePosition[     11892,        390]
CellTagsIndexPosition[     11849,        387]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
PID regul\[AAcute]tor + soustava
\[CapitalRHacek]e\[SHacek]en\[IAcute] Laplaceovou transformac\[IAcute]\
\>", "Section"],

Cell["\<\
Pozor! Nelze \[RHacek]e\[SHacek]it pouze pomoc\[IAcute] \
p\[RHacek]enos\[URing] blok\[URing], je nutn\[EAcute] uva\[ZHacek]ovat i p\
\[RHacek]enos po\[CHacek]\[AAcute]te\[CHacek]n\[IAcute]ch podm\[IAcute]nek. \
Proto \[RHacek]e\[SHacek]\[IAcute]me pomoc\[IAcute] Laplaceov\[YAcute]ch \
obraz\[URing] cel\[EAcute] soustavy rovnic.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Vstupn\[IAcute] hodnoty", "Subsection"],

Cell[BoxData[
 RowBox[{"dos", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"A", "\[Rule]", "1"}], ",", 
    RowBox[{"Kp", "\[Rule]", "2.6"}], ",", 
    RowBox[{"Ti", "\[Rule]", "1"}], ",", 
    RowBox[{"Kd", "\[Rule]", "1"}], ",", 
    RowBox[{"p", "\[Rule]", "1"}], ",", 
    RowBox[{"i", "\[Rule]", "1"}], ",", 
    RowBox[{"d", "\[Rule]", "1"}], ",", 
    RowBox[{"Ts", "\[Rule]", "5"}]}], "}"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Soustava rovnic", "Subsection"],

Cell[BoxData[
 RowBox[{"rce", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"e", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"w", "[", "t", "]"}], "-", 
       RowBox[{"r", "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"up", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"p", "*", "Kp", "*", 
       RowBox[{"e", "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"i", "*", 
       RowBox[{"e", "[", "t", "]"}]}], "==", 
      RowBox[{"Ti", "*", 
       RowBox[{
        RowBox[{"ui", "'"}], "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"ud", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"d", "*", "Kd", "*", 
       RowBox[{
        RowBox[{"e", "'"}], "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"up", "[", "t", "]"}], "+", 
       RowBox[{"ui", "[", "t", "]"}], "+", 
       RowBox[{"ud", "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"r", "[", "t", "]"}], "+", 
       RowBox[{"Ts", "*", 
        RowBox[{
         RowBox[{"r", "'"}], "[", "t", "]"}]}]}], "\[Equal]", 
      RowBox[{"u", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{"w", "[", "t", "]"}], "\[Equal]", "A"}], ",", 
     RowBox[{
      RowBox[{"w", "[", "0", "]"}], "\[Equal]", "A"}], ",", 
     RowBox[{
      RowBox[{"ui", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{
      RowBox[{"e", "[", "0", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"w", "[", "0", "]"}], "-", 
       RowBox[{"r", "[", "0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"r", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], "/.", 
   "dos"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Obrazy rovnic", "Subsection"],

Cell[BoxData[
 RowBox[{"leve", "=", 
  RowBox[{"rce", "/.", 
   RowBox[{
    RowBox[{"Equal", "[", 
     RowBox[{"ss_", ",", "tt_"}], "]"}], "\[Rule]", 
    RowBox[{"ss", "-", "tt"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"levelapl", "=", 
  RowBox[{
   RowBox[{"LaplaceTransform", "[", 
    RowBox[{"leve", ",", "t", ",", "s"}], "]"}], "/.", 
   RowBox[{
    RowBox[{"LaplaceTransform_", "[", 
     RowBox[{
      RowBox[{"c_", "[", "t", "]"}], ",", "t", ",", "s"}], "]"}], "\[Rule]", 
    RowBox[{"c", "[", "s", "]"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"rcelapl", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"levelapl", "[", 
      RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "levelapl", "]"}]}], "}"}]}], "]"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["V\[YAcute]stup", "Subsection",
 CellChangeTimes->{{3.6215915501733055`*^9, 3.6215915516803923`*^9}}],

Cell[BoxData[{
 RowBox[{"prcelk", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"Drop", "[", 
      RowBox[{"rcelapl", ",", 
       RowBox[{"-", "4"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "[", "s", "]"}], ",", 
       RowBox[{"e", "[", "s", "]"}], ",", 
       RowBox[{"up", "[", "s", "]"}], ",", 
       RowBox[{"ui", "[", "s", "]"}], ",", 
       RowBox[{"ud", "[", "s", "]"}], ",", 
       RowBox[{"u", "[", "s", "]"}], ",", 
       RowBox[{"w", "[", "s", "]"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"prcelk2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", "s", "]"}], "/.", "prcelk"}], "//", 
   "Simplify"}]}]}], "Input",
 CellChangeTimes->{
  3.621591567615303*^9, 3.621592344033712*^9, {3.6215929864174542`*^9, 
   3.6215929966670403`*^9}, {3.6215933424928207`*^9, 3.621593346924074*^9}}],

Cell[BoxData[
 RowBox[{"prpocpod", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"Take", "[", 
      RowBox[{"rcelapl", ",", 
       RowBox[{"-", "4"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"w", "[", "0", "]"}], ",", 
       RowBox[{"e", "[", "0", "]"}], ",", 
       RowBox[{"ui", "[", "0", "]"}], ",", 
       RowBox[{"r", "[", "0", "]"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6215934706101484`*^9, 3.621593527372395*^9}}],

Cell[BoxData[
 RowBox[{"prcelk3", "=", 
  RowBox[{
   RowBox[{"prcelk2", "/.", "prpocpod"}], "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.6215935786603284`*^9, 3.6215936039627757`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vystup2", "[", "t_", "]"}], "=", 
  RowBox[{"InverseLaplaceTransform", "[", 
   RowBox[{"prcelk3", ",", "s", ",", "t"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "//", "ExpToTrig"}], "//", "Chop"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"vystup2", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<r(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.6215926462649984`*^9, 3.621592856488023*^9}, {
   3.621592891015998*^9, 3.621592891991053*^9}, 3.621593648665333*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"vystup2", "[", "t", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "20"}], "}"}]}], "]"}], "//", "Chop"}], 
  ";"}]], "Input",
 CellChangeTimes->{3.621592627878947*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["P\[RHacek]enosy", "Subsection"],

Cell[BoxData[{
 RowBox[{"prPID", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"p", "*", "Kp"}], "+", 
    RowBox[{"d", "*", "Kd", "*", "s"}], "+", 
    RowBox[{"i", "*", 
     FractionBox["1", 
      RowBox[{"Ti", "*", "s"}]]}]}], "/.", "dos"}]}], "\[IndentingNewLine]", 
 RowBox[{"prsous", "=", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"1", "+", 
     RowBox[{"Ts", "*", "s"}]}]], "/.", "dos"}]}]}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ak\[CHacek]n\[IAcute] veli\[CHacek]ina", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   FractionBox["prcelk2", "prsous"], "//", "Expand"}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "/.", "prpocpod"}], "//", "Chop"}]}], "Input",
 CellChangeTimes->{{3.6215930191873283`*^9, 3.621593117194934*^9}, {
  3.6215937522882595`*^9, 3.621593763629908*^9}, {3.6215938327178597`*^9, 
  3.621593842919443*^9}, {3.621595032948509*^9, 3.6215950363107014`*^9}, {
  3.6215952155919557`*^9, 3.6215952164170027`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"u", "[", "s", "]"}], "/.", "prcelk"}], "//", "Chop"}], "//", 
   "Expand"}], "//", "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"u", "[", "s", "]"}], "/.", "prcelk"}], "/.", "prpocpod"}], "//",
     "Chop"}], "//", "Expand"}], "//", "Simplify"}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"akce2", "[", "t_", "]"}], "=", 
   RowBox[{"InverseLaplaceTransform", "[", 
    RowBox[{
     RowBox[{
      FractionBox["prcelk2", "prsous"], "/.", "prpocpod"}], ",", "s", ",", 
     "t"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<u(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{3.621593876445361*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Regula\[CHacek]n\[IAcute] odchylka", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"odchylka2", "[", "t_", "]"}], "=", 
   RowBox[{"InverseLaplaceTransform", "[", 
    RowBox[{
     FractionBox["prcelk2", 
      RowBox[{"prPID", "*", "prsous"}]], ",", "s", ",", "t"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<e(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  FractionBox["prcelk2", 
   RowBox[{"prPID", "*", "prsous"}]], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"%", "/.", "prpocpod"}], "//", "Chop"}], "//", 
  "Simplify"}]}], "Input",
 CellChangeTimes->{{3.6215931625975313`*^9, 3.621593166551757*^9}, {
  3.6215940081768956`*^9, 3.621594044463971*^9}, {3.621595010305214*^9, 
  3.621595013439393*^9}, {3.621595243010524*^9, 3.6215952437315655`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"e", "[", "s", "]"}], "/.", "prcelk"}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"e", "[", "s", "]"}], "/.", "prcelk"}], "/.", "prpocpod"}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"InverseLaplaceTransform", "[", 
    RowBox[{"%", ",", "s", ",", "t"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<e(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.6215952387782817`*^9, 3.6215952394623213`*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->"EditBar",
WindowSize->{951, 766},
WindowMargins->{{27, Automatic}, {Automatic, 7}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
Magnification->1.25,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 130, 3, 157, "Section"],
Cell[712, 27, 354, 6, 63, "Text"],
Cell[CellGroupData[{
Cell[1091, 37, 45, 0, 59, "Subsection"],
Cell[1139, 39, 412, 11, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1588, 55, 37, 0, 59, "Subsection"],
Cell[1628, 57, 1685, 51, 83, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3350, 113, 35, 0, 59, "Subsection"],
Cell[3388, 115, 199, 6, 36, "Input"],
Cell[3590, 123, 337, 9, 36, "Input"],
Cell[3930, 134, 303, 9, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4270, 148, 106, 1, 59, "Subsection"],
Cell[4379, 151, 913, 25, 83, "Input"],
Cell[5295, 178, 530, 15, 36, "Input"],
Cell[5828, 195, 190, 4, 36, "Input"],
Cell[6021, 201, 831, 19, 106, "Input"],
Cell[6855, 222, 330, 11, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7222, 238, 37, 0, 59, "Subsection"],
Cell[7262, 240, 409, 13, 96, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7708, 258, 60, 0, 59, "Subsection"],
Cell[7771, 260, 480, 10, 83, "Input"],
Cell[8254, 272, 399, 13, 60, "Input"],
Cell[8656, 287, 701, 19, 106, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9394, 311, 56, 0, 59, "Subsection"],
Cell[9453, 313, 656, 18, 106, "Input"],
Cell[10112, 333, 458, 11, 83, "Input"],
Cell[10573, 346, 822, 22, 106, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
