(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      6928,        211]
NotebookOptionsPosition[      6087,        184]
NotebookOutlinePosition[      6638,        203]
CellTagsIndexPosition[      6595,        200]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"dos", "=", 
  RowBox[{"{", 
   RowBox[{"Ts", "\[Rule]", "5"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.47583595215625*^9, 3.4758359659375*^9}}],

Cell[BoxData[
 RowBox[{"rce", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"r", "[", "t", "]"}], "+", 
       RowBox[{"Ts", "*", 
        RowBox[{
         RowBox[{"r", "'"}], "[", "t", "]"}]}]}], "\[Equal]", 
      RowBox[{"u", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], "\[Equal]", "1"}], ",", 
     RowBox[{
      RowBox[{"r", "[", "0", "]"}], "\[Equal]", "2"}], ",", 
     RowBox[{
      RowBox[{"u", "[", "0", "]"}], "\[Equal]", "1"}]}], "}"}], "/.", 
   "dos"}]}]], "Input",
 CellChangeTimes->{{3.47583607071875*^9, 3.47583609965625*^9}, {
   3.475836283671875*^9, 3.475836293078125*^9}, {3.475836323640625*^9, 
   3.475836331265625*^9}, {3.47583636765625*^9, 3.475836371890625*^9}, {
   3.47583643259375*^9, 3.47583644296875*^9}, {3.47583671228125*^9, 
   3.475836721984375*^9}, {3.47583679171875*^9, 3.475836792109375*^9}, {
   3.47583717315625*^9, 3.475837179125*^9}, {3.475837307203125*^9, 
   3.4758373074375*^9}, {3.475837480265625*^9, 3.4758374963125*^9}, 
   3.47583789240625*^9, {3.475838190984375*^9, 3.47583819140625*^9}, 
   3.475838521265625*^9}],

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{
   RowBox[{"NDSolve", "[", 
    RowBox[{"rce", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "[", "t", "]"}], ",", 
       RowBox[{"u", "[", "t", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "30"}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.47583610840625*^9, 3.475836146671875*^9}, {
  3.475836243359375*^9, 3.475836243421875*^9}, {3.475836303625*^9, 
  3.475836305046875*^9}, {3.4758363406875*^9, 3.4758363425*^9}, {
  3.47583641775*^9, 3.4758364198125*^9}, {3.4758367473125*^9, 
  3.475836750015625*^9}, {3.4758367845625*^9, 3.4758367879375*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", "t", "]"}], "/.", "res"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.47583681896875*^9, 3.475836846875*^9}}],

Cell[BoxData[
 RowBox[{"leve", "=", 
  RowBox[{"rce", "/.", 
   RowBox[{
    RowBox[{"Equal", "[", 
     RowBox[{"ss_", ",", "tt_"}], "]"}], "\[Rule]", 
    RowBox[{"ss", "-", "tt"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"levelapl", "=", 
  RowBox[{
   RowBox[{"LaplaceTransform", "[", 
    RowBox[{"leve", ",", "t", ",", "s"}], "]"}], "/.", 
   RowBox[{
    RowBox[{"LaplaceTransform_", "[", 
     RowBox[{
      RowBox[{"c_", "[", "t", "]"}], ",", "t", ",", "s"}], "]"}], "\[Rule]", 
    RowBox[{"c", "[", "s", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.4758368728125*^9, 3.475836907734375*^9}, {
  3.47583695615625*^9, 3.47583698634375*^9}, {3.475837050234375*^9, 
  3.475837072*^9}}],

Cell[BoxData[
 RowBox[{"rcelapl", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"levelapl", "[", 
      RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "levelapl", "]"}]}], "}"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"vystup", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{"rcelapl", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "[", "s", "]"}], ",", 
       RowBox[{"u", "[", "s", "]"}], ",", 
       RowBox[{"r", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "0", "]"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.475837005859375*^9, 3.47583701815625*^9}, {
  3.4758370824375*^9, 3.475837114671875*^9}, {3.475837229*^9, 
  3.4758372375625*^9}, {3.621594430165032*^9, 3.621594433909246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vystup2", "[", "t_", "]"}], "=", 
  RowBox[{"InverseLaplaceTransform", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "s", "]"}], "/.", "vystup"}], ",", "s", ",", "t"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.475837132*^9, 3.47583715990625*^9}, {
  3.475837263734375*^9, 3.475837273671875*^9}, {3.6215947600248985`*^9, 
  3.621594765729225*^9}}],

Cell[BoxData[{
 RowBox[{"vystupb", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"Take", "[", 
      RowBox[{"rcelapl", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "[", "s", "]"}], ",", 
       RowBox[{"u", "[", "s", "]"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"vystupc", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"Take", "[", 
      RowBox[{"rcelapl", ",", 
       RowBox[{"-", "2"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "0", "]"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6215945786775265`*^9, 3.621594593045348*^9}, {
  3.621594691594985*^9, 3.621594700061469*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vystup3", "[", "t_", "]"}], "=", 
  RowBox[{"InverseLaplaceTransform", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "[", "s", "]"}], "/.", "vystupb"}], "/.", 
     RowBox[{
      RowBox[{"r", "[", "0", "]"}], "\[Rule]", "0"}]}], ",", "s", ",", "t"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6215947128051977`*^9, 3.621594738494667*^9}, {
  3.621594771714567*^9, 3.621594812829919*^9}}]
},
WindowToolbars->"EditBar",
WindowSize->{909, 775},
WindowMargins->{{131, Automatic}, {52, Automatic}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.25, 1.25 Inherited],
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 168, 4, 36, "Input"],
Cell[716, 26, 1143, 27, 36, "Input"],
Cell[1862, 55, 689, 16, 36, "Input"],
Cell[2554, 73, 259, 7, 36, "Input"],
Cell[2816, 82, 199, 6, 36, "Input"],
Cell[3018, 90, 491, 12, 36, "Input"],
Cell[3512, 104, 303, 9, 36, "Input"],
Cell[3818, 115, 574, 14, 36, "Input"],
Cell[4395, 131, 393, 10, 36, "Input"],
Cell[4791, 143, 845, 25, 60, "Input"],
Cell[5639, 170, 444, 12, 36, "Input"]
}
]
*)

(* End of internal cache information *)
